var mWidth = 0;
var mHeight = 0;
var maxFacesTracker = 0;
var maxFacesDetector = 0;
var numOfFaces = 0;
var faceIndex = 0;
var trackerStatus = 0;
//
var emotionFilterTime = 500;
var genderFilterTime = 1000;
var ageNumFilterFrames = 10;
var NUM_EMOTIONS = 7;
//
var emotionAverageList = [];
var emotionSumList = [];
var ageFilterList = [];
var trackLastFewEmotionList =  [];
var trackLastFewGenderList = [];
var currMaxTrackingQuality = [];
//
var GenderSum = [];
var GenderAverage = [];
//
var TrackingQualityDELTA = [];
var TrackingQualityList = [];
var ageFilterFramesReached = [];
var currentTrackingQuality = [];
var ageFilterCount = [];
var AgeSmoothed = [];
//
var TfaceDataNoseOld = [];
var AgeDetect = [];
var GenderDetect = [];
var emotionListDetect = [];
//
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
if (ENVIRONMENT_IS_WORKER)
{
	var locationObj = self.location;
}

self.onmessage = function (msg) {
	switch (msg.data.aTopic) {
		case 'resolution':
			mWidth = msg.data.mWidth;
			mHeight = msg.data.mHeight;
			maxFacesTracker = msg.data.maxFacesTracker;
			maxFacesDetector = msg.data.maxFacesDetector;
			break;
		case 'sendFrameTrack':
			imageData = new Uint8ClampedArray(msg.data.imageData);
			analyserControlOptions = JSON.parse(msg.data.analyserControlOptions);
			trackerStatus = JSON.parse(msg.data.numFaces);
			
			if (analyserInitialized)
			{
				//obtain FaceData in ArrayBuffer
				faceDataBuffer = msg.data.inFaceData; 
				//create typedArray object from ArrayBuffer
				faceDataBufferFloatArray = new Float32Array(faceDataBuffer);
				m_faceDataArray.get(0).deserializeBuffer(faceDataBufferFloatArray);
			}
			trackAnalysis();
			break;
		case 'sendFrameDetect':
			imageData = new Uint8ClampedArray(msg.data.imageData);
			numOfFaces = msg.data.numFaces;
			
			if (analyserInitialized)
			{
				var DfaceDataStringArray = msg.data.inFaceData.split("||", maxFacesDetector);
				
				for(var i = 0; i < numOfFaces; i++)
				{
					m_DfaceDataArray.get(i).deserializeJson(DfaceDataStringArray[i]);
				}
			}
			detectAnalysis();
			break;
		case 'trackStatus':
			resetAnalysisParametersForEachFace();
			break;
		default:
			throw 'no aTopic on incoming message to Worker';
	}
}

importScripts('../../lib/visageSDK.js');

licenseName = "dev_html5.vlc"
licenseURL = "dev_html5.vlc"

var locateFile = function(dataFileName) {var relativePath = "../../lib/" + dataFileName; return relativePath};
var VisageModule = VisageModule({onRuntimeInitialized: onModuleInitialized, locateFile: locateFile});
var preloadFiles = function() {
		VisageModule.FS_createPreloadedFile('/', licenseName, licenseURL, true, false, function(){ },  function(){ console.log("Loading License Failed!") }); 	
	};
VisageModule.preRun.push(preloadFiles);

importScripts('../../lib/visageAnalysisData.js');

function onModuleInitialized()
{
	//wait for initialization if the first message has not yet arrived from the main thread
	//it is enough to check only one value set in onmessage event with the topic 'resolution'
	if (mWidth === 0)
	{
		setTimeout(onModuleInitialized, 100);
		return
	}

	ppixels = VisageModule._malloc(mWidth*mHeight*4);
	pixels = new Uint8Array(VisageModule.HEAPU8.buffer, ppixels, mWidth*mHeight*4);
	
	alert = function(msg) 
	{ 
		console.log(msg); 
	}
	
	VisageModule.initializeLicenseManager(licenseName);
	m_FaceAnalyser = new VisageModule.VisageFaceAnalyser();
	
	m_faceDataArray = new VisageModule.FaceDataVector();
	m_DfaceDataArray = new VisageModule.FaceDataVector();
	for (var i = 0; i < maxFacesTracker; ++i)
	{
		m_faceDataArray.push_back(new VisageModule.FaceData());
	}

	for(var i = 0; i < maxFacesDetector; ++i)
	{
		m_DfaceDataArray.push_back(new VisageModule.FaceData());
	}
	
	for(var i = 0; i < maxFacesTracker; ++i)
	{
		ageFilterList[i] = [];
		trackLastFewEmotionList[i] = [];
		trackLastFewGenderList[i] = [];
		currMaxTrackingQuality[i] = 0.6;
		emotionSumList[i] = [0,0,0,0,0,0,0];
		emotionAverageList[i] = [0,0,0,0,0,0,0];
		
		GenderSum[i] = 0;
		GenderAverage[i] = 0;

		TrackingQualityDELTA[i] = 0;
		TrackingQualityList[i] = [];
		ageFilterFramesReached[i] = 0;
		currentTrackingQuality[i] = 0;
		ageFilterCount[i] = 0;
		AgeSmoothed[i] = 0;
		
		TfaceDataNoseOld[i] = [];
	}
	
	for(var i = 0; i < maxFacesDetector; ++i)
	{
		emotionListDetect[i] = [0,0,0,0,0,0,0];
		AgeDetect[i] = -1;
		GenderDetect[i] = -1;
	}
	
	analyserInitialized = true;
	self.postMessage({aTopic:'initialization done'});
	
}

/**
* Resets analysis parameters for particular tracked face.
*/
function resetAnalysisParameters(faceIndex)
{
	trackLastFewGenderList[faceIndex] = [];
	trackLastFewEmotionList[faceIndex] =[];		
	ageFilterList[faceIndex] = [];

	emotionSumList[faceIndex] = [0,0,0,0,0,0,0];
	emotionAverageList[faceIndex] = [0,0,0,0,0,0,0];
	
	currMaxTrackingQuality[faceIndex] = 0.6;

	GenderSum[faceIndex] = 0;
	GenderAverage[faceIndex] = -1;

	TrackingQualityDELTA[faceIndex] = 0;
	TrackingQualityList[faceIndex] = [];
	ageFilterFramesReached[faceIndex] = 0;
	currentTrackingQuality[faceIndex] = 0;
	ageFilterCount[faceIndex] = 0;
	AgeSmoothed[faceIndex] = -1;
	
	TfaceDataNoseOld[faceIndex] = [];

	self.postMessage({aTopic:'analysis reset', emotions : emotionAverageList, gender: GenderAverage, age: AgeSmoothed});
}


/**
* Resets analysis parameters for each tracked face.
*/
function resetAnalysisParametersForEachFace()
{
	for(var i = 0; i < maxFacesTracker; ++i)
	{
		trackLastFewGenderList[faceIndex] = [];
		trackLastFewEmotionList[faceIndex] =[];		
		ageFilterList[faceIndex] = [];

		emotionSumList[faceIndex] = [0,0,0,0,0,0,0];
		emotionAverageList[faceIndex] = [0,0,0,0,0,0,0];

		currMaxTrackingQuality[faceIndex] = 0.6;

		GenderSum[faceIndex] = 0;
		GenderAverage[faceIndex] = -1;

		TrackingQualityDELTA[faceIndex] = 0;
		TrackingQualityList[faceIndex] = [];
		ageFilterFramesReached[faceIndex] = 0;
		currentTrackingQuality[faceIndex] = 0;
		ageFilterCount[faceIndex] = 0;
		AgeSmoothed[faceIndex] = -1;

		TfaceDataNoseOld[faceIndex] = [];
	}
		
	for(var i = 0; i < maxFacesDetector; ++i)
	{
		emotionListDetect[i] = [0,0,0,0,0,0,0];
		AgeDetect[i] = -1;
		GenderDetect[i] = -1;
	}
	
	
	self.postMessage({aTopic:'analysis reset', emotions : emotionAverageList, gender: GenderAverage, age: AgeSmoothed});
}


/**
* If TrackStatus is OK (i.e equal to 1) calls function for estimating and filtering the values of age, gender and emotions for each 
* particular tracked face.
*/
function trackAnalysis()
{
	if (analyserInitialized)
	{
		for(var i=0; i<imageData.length; i+=1)
		{
			pixels[i] = imageData[i];
		}
		
		for(var index = 0; index < maxFacesTracker; ++index)
		{
			if(trackerStatus[index] === 1 && trackTest(index))
			{
				faceData = m_faceDataArray.get(index);
		
				if(analyserControlOptions[0] == true)
					TrackEmotionFilter(faceData, index);
				if(analyserControlOptions[1] == true)
					TrackGenderFilter(faceData, index);
				if(analyserControlOptions[2] == true)
					TrackAgeFilter(faceData, index);
			}
			else
				resetAnalysisParameters(index);
		
		}
	}
	
	self.postMessage({aTopic:'analysis results track', emotions : emotionAverageList, gender: GenderAverage, age: AgeSmoothed});
}

/**
* Performs emotion analysis for given face (faceIndex). 
* Results are saved to emotionAverageList List for a faceIndex face.
*/
function TrackEmotionFilter(faceData, faceIndex)
{
	if(withinConstraints(faceIndex))
	{
		var emotions = new VisageModule.VectorFloat();
		var emotion = m_FaceAnalyser.estimateEmotion(mWidth, mHeight, ppixels, faceData, emotions);
			
		if(emotion)
		{
			var emotionsArray = [];
			for (var numEmotion = 0; numEmotion < NUM_EMOTIONS; ++numEmotion)
			{
				emotionsArray.push(emotions.get(numEmotion));
			}
			
			emotionNumFilterFrames = Math.round(emotionFilterTime*faceData.frameRate / 1000);
			
			//updates the emotion data
			trackLastFewEmotionList[faceIndex].push(emotionsArray);
			
			if(trackLastFewEmotionList[faceIndex].length > emotionNumFilterFrames)
			{
				for(var s = 0; s < (trackLastFewEmotionList[faceIndex].length - emotionNumFilterFrames); ++s)
				{
					trackLastFewEmotionList[faceIndex].shift();
				}
			}
			
			//calculates the emotions applying the filter
			for(var i = 0; i < trackLastFewEmotionList[faceIndex].length; i++)
			{
				for(var j = 0; j < NUM_EMOTIONS; j++)
				{
					emotionSumList[faceIndex][j] += trackLastFewEmotionList[faceIndex][i][j];
				}
			}
			
			for(var j = 0; j < NUM_EMOTIONS; j++)
			{
				emotionAverageList[faceIndex][j] = emotionSumList[faceIndex][j] / trackLastFewEmotionList[faceIndex].length;
				emotionSumList[faceIndex][j] = 0;
			}
		}	
		emotions.delete();	
	}
}

/**
* Performs gender analysis for given face (faceIndex). 
* Results are saved to GenderAverage array for a faceIndex face.
*/
function TrackGenderFilter(faceData, faceIndex)
{ 
	if(withinConstraints(faceIndex))
	{
		var gender = m_FaceAnalyser.estimateGender(mWidth, mHeight, ppixels, faceData);

		if(gender >= 0)
		{
			genderNumFilterFrames = Math.round(genderFilterTime*faceData.frameRate/ 1000);

			trackLastFewGenderList[faceIndex].push(gender);
			
			if(trackLastFewGenderList[faceIndex].length > genderNumFilterFrames)
			{
				for(var i = 0; i < (trackLastFewGenderList[faceIndex].length - genderNumFilterFrames); i++)
				{
					trackLastFewGenderList[faceIndex].shift();
				}
			}
			
			//calculates the gender applying the filter
			for(var i = 0; i < trackLastFewGenderList[faceIndex].length; i++)
			{
				GenderSum[faceIndex] += trackLastFewGenderList[faceIndex][i];	
			}
			
			GenderAverage[faceIndex] = Math.round(GenderSum[faceIndex] / trackLastFewGenderList[faceIndex].length);
			GenderSum[faceIndex] = 0;
		}
		else
			return;
	}
}

/**
* Performs age analysis for given face (faceIndex).
* Age is estimated if current tracking quality is greater than current max tracking quality increased by 5*k% (where k is value between 1 and 10), 
* less than 10 age values is collected and face position is frontal. 
* After 10 age values is collected, current max tracking qulity is changed. Age will be estimated only if the same conditions are satisfied, 
* except the current trecking quality 
* has to be greated than current max tracking quality increased by 0.5*k% (where k is an integer).
* Results are saved to AgeSmoothed array for a faceIndex face.
*/
function TrackAgeFilter(faceData, faceIndex)
{	
	var currentTrackingQuality = m_faceDataArray.get(faceIndex).trackingQuality;
	
	if (currMaxTrackingQuality[faceIndex] * (1.0 + TrackingQualityDELTA[faceIndex]) <= currentTrackingQuality && ageFilterCount[faceIndex] <= ageNumFilterFrames && withinConstraints(faceIndex))
	{
		
		TrackingQualityList[faceIndex].push(currentTrackingQuality);
		var age = m_FaceAnalyser.estimateAge(mWidth, mHeight, ppixels, faceData);
		ageFilterList[faceIndex].push(age);
		//
		ageFilterCount[faceIndex]++;
		TrackingQualityDELTA[faceIndex] += DeltaStep(ageFilterFramesReached[faceIndex]);
	}

	if (ageFilterCount[faceIndex] == ageNumFilterFrames)
	{
		var ageSUM = 0;
		for(var i = 0; i < ageFilterList[faceIndex].length; ++i)
		{
			ageSUM += ageFilterList[faceIndex][i];	
		}
		AgeSmoothed[faceIndex] = Math.round(ageSUM/ageFilterList[faceIndex].length);
		//
		ageFilterCount[faceIndex] = 0;
		currMaxTrackingQuality[faceIndex] = Math.max(...TrackingQualityList[faceIndex]);
		TrackingQualityDELTA[faceIndex] = 0.0;
		ageFilterFramesReached[faceIndex]++;
	}
	else
	{
		var ageSUM = 0;
		for(var i = 0; i < ageFilterList[faceIndex].length; ++i)
		{
			ageSUM += ageFilterList[faceIndex][i];	
		}
	
		if(ageFilterList[faceIndex].length != 0)
		{
			AgeSmoothed[faceIndex] = Math.round(ageSUM/ageFilterList[faceIndex].length);
		}	
	}
}


function DeltaStep(ageFilterFramesReached)
{
	if (ageFilterFramesReached == 0)
	{
		return 0.05;
	}
	else
		return 0.005;
}

/**
* If face position is within constraints performs face analysis
*/
function withinConstraints(faceIndex)
{
	var translationX = m_faceDataArray.get(faceIndex).getFaceTranslation()[0];
	var translationY = m_faceDataArray.get(faceIndex).getFaceTranslation()[1];
	var translationZ = m_faceDataArray.get(faceIndex).getFaceTranslation()[2];
	
	var rotationX = m_faceDataArray.get(faceIndex).getFaceRotation()[0];
	var rotationY = m_faceDataArray.get(faceIndex).getFaceRotation()[1];
	var rotationZ = m_faceDataArray.get(faceIndex).getFaceRotation()[2];
	
	var head_pitch_compensated_rad = rotationX - Math.atan2(translationY, translationZ);
	var head_yaw_compensated_rad = rotationY - Math.atan2(translationX, translationZ);
	var head_roll_rad = rotationZ;
	
	var head_pitch_compensated_deg = head_pitch_compensated_rad * 180 / Math.PI
	var head_yaw_compensated_deg =  head_yaw_compensated_rad * 180 / Math.PI
	var head_roll_deg = head_roll_rad * 180 / Math.PI

	var CONSTRAINT_ANGLE = 40;
	
	if (Math.abs(head_pitch_compensated_deg) > CONSTRAINT_ANGLE || 
		Math.abs(head_yaw_compensated_deg) > CONSTRAINT_ANGLE || 
		Math.abs(head_roll_deg) > CONSTRAINT_ANGLE || 
		m_faceDataArray.get(faceIndex).faceScale < 40)
	{
		return false;
	}
	return true;	
}

/**
* Test if the face from the last frame is the same in this frame (used by tracker)
*/
function trackTest(faceIndex)
{
	var allowedDiff = 0.1;
	var faceData = m_faceDataArray.get(faceIndex);
	var factorDiffX = allowedDiff * faceData.faceScale / mWidth;
	var factorDiffY = allowedDiff * faceData.faceScale / mHeight;
	if(TfaceDataNoseOld[faceIndex].length == 0)
	{
		TfaceDataNoseOld[faceIndex] = [faceData.getFeaturePoints2D().getFPPos(12,1)[0],faceData.getFeaturePoints2D().getFPPos(12,1)[1]];
		return true;
	}
	else
	{
		if(
		((faceData.getFeaturePoints2D().getFPPos(12,1)[0] >= (TfaceDataNoseOld[faceIndex][0] - factorDiffX)) && 
		(faceData.getFeaturePoints2D().getFPPos(12,1)[0] <= (TfaceDataNoseOld[faceIndex][0] + factorDiffX)))
		|| 
		((faceData.getFeaturePoints2D().getFPPos(12,1)[1] >= (TfaceDataNoseOld[faceIndex][1] - factorDiffY)) && 
		(faceData.getFeaturePoints2D().getFPPos(12,1)[1] <= (TfaceDataNoseOld[faceIndex][1] + factorDiffY)))
		)
		{
			TfaceDataNoseOld[faceIndex] = [faceData.getFeaturePoints2D().getFPPos(12,1)[0],faceData.getFeaturePoints2D().getFPPos(12,1)[1]];
			return true;
		}
		else
		{
			TfaceDataNoseOld[faceIndex] = [faceData.getFeaturePoints2D().getFPPos(12,1)[0],faceData.getFeaturePoints2D().getFPPos(12,1)[1]];
			return false;
		}
	}
}

/**
* Calls function for estimating age, gender and emotions for each detected face on image.
*/
function detectAnalysis()
{
	for(var i=0; i<imageData.length; i+=1)
	{
		pixels[i] = imageData[i];
	}
	
	for (var i = 0; i < numOfFaces; i++)
	{
		var emotions = new VisageModule.VectorFloat();
		var emotionsArray = [];
		var emotion = m_FaceAnalyser.estimateEmotion(mWidth, mHeight, ppixels, m_DfaceDataArray.get(i), emotions);
		//
		if (emotion)
		{
			for (var j = 0; j < NUM_EMOTIONS; ++j)
			{
				emotionsArray.push(emotions.get(j));	
				emotionListDetect[i][j] = emotionsArray[j];
			}
			emotions.delete();		
		}
	
		var age = m_FaceAnalyser.estimateAge(mWidth, mHeight, ppixels, m_DfaceDataArray.get(i)); 

		AgeDetect[i] = age;
			
	
		var gender = m_FaceAnalyser.estimateGender(mWidth, mHeight, ppixels, m_DfaceDataArray.get(i));
		
		GenderDetect[i] = gender;
	}
	
	self.postMessage({aTopic:'analysis results detect', emotions: emotionListDetect, gender: GenderDetect, age: AgeDetect});
	
}
